import { MagicString } from './magic-string.js';
import { SFCScriptBlock, SFCDescriptor } from '@vue/compiler-sfc';
import 'magic-string';
import '@babel/types';

declare type _SFCScriptBlock = Omit<SFCScriptBlock, 'scriptAst' | 'scriptSetupAst'>;
declare type SFCCompiled = Omit<SFCDescriptor, 'script' | 'scriptSetup'> & {
    script?: _SFCScriptBlock | null;
    scriptSetup?: _SFCScriptBlock | null;
    scriptCompiled: SFCScriptBlock;
    lang: string | undefined;
};
declare const parseSFC: (code: string, id: string) => SFCCompiled;
declare const addNormalScript: ({ script, lang }: SFCCompiled, s: MagicString) => {
    start(): number;
    end(): void;
};

export { SFCCompiled, _SFCScriptBlock, addNormalScript, parseSFC };
